using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.EnterpriseServices;

namespace NetSigAutoWebSvc
{
	/// <summary>
	/// Summary description for TransferWebSvc.
	/// </summary>
	public class TransferWebSvc : System.Web.Services.WebService
	{
		public TransferWebSvc()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		
		//[WebMethod]
		[WebMethod(TransactionOption=TransactionOption.RequiresNew)]
		public void Transfer(string FromAccount, string ToAccount, string Amount)
		{
			const string CONNECT_STRING = @"server=BA03\NetSDK; uid=SimpleBankUser; pwd=password; database=SimpleBank";

			SqlConnection conn = null;
			SqlCommand cmd = null;

			try
			{
				conn = new SqlConnection(CONNECT_STRING);
				conn.Open();
				cmd = conn.CreateCommand();

				//Debit the Amount from the "FromAccount"
				cmd.CommandText = "Debit";			
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@FromAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@FromAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = FromAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();

				cmd.Parameters.Clear();

				//Credit Amount to the "ToAccount"
				cmd.CommandText = "Credit";
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@ToAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@ToAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = ToAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();				
			}
			catch
			{
				throw; //Must throw the exception for transaction to work
			}
			finally
			{
				if (conn != null)
					if (conn.State == ConnectionState.Open)
						conn.Close();
			}				
		}
	}
}
