using System;
using System.Data;
using System.Data.SqlClient;
using System.EnterpriseServices;


namespace NetSigAutomaticTx
{
	/// <summary>
	/// Summary description for TransferTx.
	/// </summary>
	[Transaction(TransactionOption.RequiresNew)]
	public class TransferTx : ServicedComponent
	{
		private const string CONNECT_STRING = @"server=BA03\NetSDK; uid=SimpleBankUser; pwd=password; database=SimpleBank";

		public TransferTx()
		{			
		}

		[AutoComplete]
		public void TransferFunds(string FromAccount, string ToAccount, string Amount)
		{
			SqlConnection conn = null;
			SqlCommand cmd = null;

			try
			{
				conn = new SqlConnection(CONNECT_STRING);
				conn.Open();
				cmd = conn.CreateCommand();

				//Debit the Amount from the "FromAccount"
				cmd.CommandText = "Debit";			
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@FromAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@FromAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = FromAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();

				cmd.Parameters.Clear();

				//Credit Amount to the "ToAccount"
				cmd.CommandText = "Credit";
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@ToAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@ToAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = ToAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();		
				
				//ContextUtil.SetComplete();
			}
			catch
			{
				//ContextUtil.SetAbort();
				throw; //Must throw the exception for transaction to work
			}
			finally
			{
				if (conn != null)
					if (conn.State == ConnectionState.Open)
						conn.Close();
			}			
		}
	}
}
