using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace NetSigManualTxDemo
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		private const string CONNECT_STRING = @"server=BA03\NetSDK; uid=SimpleBankUser; pwd=password; database=SimpleBank";

		protected System.Web.UI.WebControls.DataGrid dgAccount;
		protected System.Web.UI.WebControls.TextBox txtFromAccount;
		protected System.Web.UI.WebControls.TextBox txtToAccount;
		protected System.Web.UI.WebControls.Button btnTransfer;
		protected System.Web.UI.WebControls.Label lblMessage;
		protected System.Web.UI.WebControls.TextBox txtAmount;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				BindGrid();
		}

		public void BindGrid()
		{
			SqlConnection conn = null;
			SqlCommand cmd = null;
			SqlDataReader reader = null;

			try
			{
				conn = new SqlConnection(CONNECT_STRING);
				conn.Open();
				cmd = conn.CreateCommand();

				cmd.CommandText = "select * from Account";
				cmd.CommandType = CommandType.Text;

				reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
				dgAccount.DataSource = reader;
				dgAccount.DataBind();				
			}
			catch(Exception e)
			{
				lblMessage.Text = e.Message;
			}
			finally
			{
				if (conn != null)
					if (conn.State == ConnectionState.Open)
						conn.Close();

				if (reader != null) reader.Close();			
			}
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnTransfer.Click += new System.EventHandler(this.btnTransfer_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnTransfer_Click(object sender, System.EventArgs e)
		{
			string FromAccount = txtFromAccount.Text;
			string ToAccount = txtToAccount.Text;
			string Amount = txtAmount.Text;

			SqlConnection conn = null;
			SqlCommand cmd = null;
			SqlTransaction tx = null;

			try
			{
				conn = new SqlConnection(CONNECT_STRING);
				conn.Open();

				tx = conn.BeginTransaction();	//Create Transaction object

				cmd = conn.CreateCommand();
				cmd.Transaction = tx;			//Associate Command object with Transaction object

				//Debit the Amount from the "FromAccount"
				cmd.CommandText = "Debit";
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@FromAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@FromAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = FromAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();

				cmd.Parameters.Clear();

				//Credit Amount to the "ToAccount"
				cmd.CommandText = "Credit";				
				cmd.Parameters.Add("@ToAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@ToAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = ToAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();

				tx.Commit();				//Commit transaction

				lblMessage.ForeColor = Color.Green;
				lblMessage.Text = "Transaction Succeeded!";
			}
			catch(Exception ex)
			{
				tx.Rollback();				//Rollback transaction
				lblMessage.ForeColor = Color.Red;
				lblMessage.Text = "Transaction failed! - " + ex.Message;				
			}
			finally
			{
				if (conn != null)
					if (conn.State == ConnectionState.Open)
						conn.Close();
			}						

			BindGrid();					//Refresh Grid
		}
	
	}
}
