using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace NetSigTxPageDemo
{
	/// <summary>
	/// Summary description for TransferTx.
	/// </summary>
	public class TransferTx : System.Web.UI.Page
	{
		private const string CONNECT_STRING = @"server=BA03\netsdk; uid=SimpleBankUser; pwd=password; database=SimpleBank";

		protected System.Web.UI.WebControls.Label lblMessage;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			string FromAccount = Request.QueryString["FromAccount"];
			string ToAccount = Request.QueryString["ToAccount"];
			string Amount = Request.QueryString["Amount"];

			SqlConnection conn = null;
			SqlCommand cmd = null;

			try
			{
				conn = new SqlConnection(CONNECT_STRING);
				conn.Open();
				cmd = conn.CreateCommand();

				//Debit the Amount from the "FromAccount"
				cmd.CommandText = "Debit";			
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@FromAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@FromAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = FromAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();

				cmd.Parameters.Clear();

				//Credit Amount to the "ToAccount"
				cmd.CommandText = "Credit";
				cmd.CommandType = CommandType.StoredProcedure;
				cmd.Parameters.Add("@ToAccountNo", SqlDbType.VarChar, 50);
				cmd.Parameters.Add("@ToAmount", SqlDbType.Decimal);
				cmd.Parameters[0].Value = ToAccount;
				cmd.Parameters[1].Value = Amount;
				cmd.ExecuteNonQuery();
				
				lblMessage.ForeColor = Color.Green;
				lblMessage.Font.Bold = true;
				lblMessage.Text = "Transaction Succeeded!";
			}
			catch
			{
				throw; //Must throw the exception for transaction to work
			}
			finally
			{
				if (conn != null)
					if (conn.State == ConnectionState.Open)
						conn.Close();
			}			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
