IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'SimpleBank')
	DROP DATABASE [SimpleBank]
GO

CREATE DATABASE [SimpleBank]  ON (NAME = N'SimpleBank', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL$NetSDK\Data\SimpleBank.mdf' , SIZE = 1, FILEGROWTH = 10%) LOG ON (NAME = N'SimpleBank_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL$NetSDK\Data\SimpleBank_log.LDF' , FILEGROWTH = 10%)
 COLLATE SQL_Latin1_General_CP1_CI_AS
GO

exec sp_dboption N'SimpleBank', N'autoclose', N'true'
GO

exec sp_dboption N'SimpleBank', N'bulkcopy', N'false'
GO

exec sp_dboption N'SimpleBank', N'trunc. log', N'true'
GO

exec sp_dboption N'SimpleBank', N'torn page detection', N'true'
GO

exec sp_dboption N'SimpleBank', N'read only', N'false'
GO

exec sp_dboption N'SimpleBank', N'dbo use', N'false'
GO

exec sp_dboption N'SimpleBank', N'single', N'false'
GO

exec sp_dboption N'SimpleBank', N'autoshrink', N'true'
GO

exec sp_dboption N'SimpleBank', N'ANSI null default', N'false'
GO

exec sp_dboption N'SimpleBank', N'recursive triggers', N'false'
GO

exec sp_dboption N'SimpleBank', N'ANSI nulls', N'false'
GO

exec sp_dboption N'SimpleBank', N'concat null yields null', N'false'
GO

exec sp_dboption N'SimpleBank', N'cursor close on commit', N'false'
GO

exec sp_dboption N'SimpleBank', N'default to local cursor', N'false'
GO

exec sp_dboption N'SimpleBank', N'quoted identifier', N'false'
GO

exec sp_dboption N'SimpleBank', N'ANSI warnings', N'false'
GO

exec sp_dboption N'SimpleBank', N'auto create statistics', N'true'
GO

exec sp_dboption N'SimpleBank', N'auto update statistics', N'true'
GO

use [SimpleBank]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Credit]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Credit]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Debit]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Debit]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Account]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Account]
GO

CREATE TABLE [dbo].[Account] (
	[AccountNo] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[Amount] [decimal](18, 0) NULL 
) ON [PRIMARY]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE dbo.Credit
	(
		@ToAccountNo varchar(50),
		@ToAmount decimal 
	)
AS
	set nocount on
	
	UPDATE Account
	SET Amount = Amount + @ToAmount 
	WHERE AccountNo = @ToAccountNo

	IF @@RowCount = 0	
		RAISERROR('Invalid To Account Number', 11, 1)
  

	


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE dbo.Debit
(
	@FromAccountNo varchar(50),
	@FromAmount decimal 
)
AS
	set nocount on
	
	UPDATE Account
	SET Amount = Amount - @FromAmount
	WHERE AccountNo = @FromAccountNo

	IF @@RowCount = 0 
		RAISERROR('Invalid From Account Number', 11, 1)  

	DECLARE @Amount decimal
	SELECT @Amount = Amount FROM Account
	WHERE AccountNo = @FromAccountNo

	IF @Amount < 0
		RAISERROR('Insufficient funds', 11, 1)  

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

